#include <unistd.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <stdio.h>
#include <stdint.h>

#define SOCK_PATH "/tmp/cexec.sock"
#define LISTEN_BACKLOG 4
#define BUF_SIZE 16
#define HELLO_MSG "hello world"

#define handle_error(msg) do { perror(msg); exit(EXIT_FAILURE); } while(0)

void communicate(int sfd) {
    char buf[BUF_SIZE];
    struct msghdr message;
    struct iovec iov;

    memset(&message, 0, sizeof(struct msghdr));
    message.msg_name = NULL;
    message.msg_namelen = 0;
    message.msg_iov = &iov;
    message.msg_iovlen = 1;
    message.msg_control = NULL;
    message.msg_controllen = 0;

    iov.iov_base = HELLO_MSG;
    iov.iov_len = sizeof(HELLO_MSG);
    if (sendmsg(sfd, &message, 0) == -1)
        handle_error("sendmsg hello");
    
    /* file descriptor; send stdout */
    iov.iov_base = buf;
    iov.iov_len = sizeof(int);
    struct cmsghdr *cmsg;
    char cmsgbuf[CMSG_SPACE(sizeof(int))];
    message.msg_control = cmsgbuf;
    message.msg_controllen = sizeof(cmsgbuf);
    cmsg = CMSG_FIRSTHDR(&message);
    cmsg->cmsg_level = SOL_SOCKET;
    cmsg->cmsg_type = SCM_RIGHTS;
    cmsg->cmsg_len = CMSG_LEN(sizeof(int));
    message.msg_controllen = cmsg->cmsg_len;
    int *fdptr = (int *)CMSG_DATA(cmsg);
    ((int *)buf)[0] = 1;
    *fdptr = 1;
    printf("sending message now\n");
    if (sendmsg(sfd, &message, 0) == -1)
        handle_error("sendmsg fd");
}

int main() {
    int sfd;
    struct sockaddr_un addr;
    socklen_t addr_size;
    
    sfd = socket(AF_UNIX, SOCK_SEQPACKET, 0);
    if (sfd == -1)
        handle_error("socket");

    /* Clear structure */
    memset(&addr, 0, sizeof(struct sockaddr_un));
    addr.sun_family = AF_UNIX;
    strncpy(addr.sun_path, SOCK_PATH, sizeof(addr.sun_path) - 1);

    addr_size = sizeof(struct sockaddr_un);
    if (connect(sfd, (struct sockaddr *) &addr, addr_size) == -1)
        handle_error("connect");

    communicate(sfd);

    close(sfd);

    return 0;
}

